{
  type color = Red | Green | Blue | Cyan | Magenta | Yellow | Black | White | UnknownColor
  type token =
    Open_B | Close_B
  | Open_EM | Close_EM
  | Open_I | Close_I
  | Open_PL | Close_PL
  | Open_S | Close_S
  | Open_TT | Close_TT
  | Open_U | Close_U
  | Open_Size of int | Close_Size of int
  | Open_Color of color | Close_Color of color
  | Text of string
  | Space of string
  | EOF
}

rule token = parse
  "<B>"		{Open_B}
| "</B>"	{Close_B}
| "<EM>"	{Open_EM}
| "</EM>"	{Close_EM}
| "<I>"		{Open_I}
| "</I>"	{Close_I}
| "<PL>"	{Open_PL}
| "</PL>"	{Close_PL}
| "<S>"		{Open_S}
| "</S>"	{Close_S}
| "<TT>"	{Open_TT}
| "</TT>"	{Close_TT}
| "<U>"		{Open_U}
| "</U>"	{Close_U}
| "<0>"		{Open_Size 0}
| "</0>"	{Close_Size 0}
| "<1>"		{Open_Size 1}
| "</1>"	{Close_Size 1}
| "<2>"		{Open_Size 2}
| "</2>"	{Close_Size 2}
| "<3>"		{Open_Size 3}
| "</3>"	{Close_Size 3}
| "<4>"		{Open_Size 4}
| "</4>"	{Close_Size 4}
| "<5>"		{Open_Size 5}
| "</5>"	{Close_Size 5}
| "<6>"		{Open_Size 6}
| "</6>"	{Close_Size 6}
| "<7>"		{Open_Size 7}
| "</7>"	{Close_Size 7}
| "<8>"		{Open_Size 8}
| "</8>"	{Close_Size 8}
| "<9>"		{Open_Size 9}
| "</9>"	{Close_Size 9}
| "<r>"		{Open_Color Red}
| "</r>"	{Close_Color Red}
| "<g>"		{Open_Color Green}
| "</g>"	{Close_Color Green}
| "<b>"		{Open_Color Blue}
| "</b>"	{Close_Color Blue}
| "<c>"		{Open_Color Cyan}
| "</c>"	{Close_Color Cyan}
| "<m>"		{Open_Color Magenta}
| "</m>"	{Close_Color Magenta}
| "<y>"		{Open_Color Yellow}
| "</y>"	{Close_Color Yellow}
| "<k>"		{Open_Color Black}
| "</k>"	{Close_Color Black}
| "<w>"		{Open_Color White}
| "</w>"	{Close_Color White}
| [^ '<' '>' '\r' '\n' '\t' ' ']+	{Text (Lexing.lexeme lexbuf)}
| ['\r' '\n' '\t' ' ']+	{Space (Lexing.lexeme lexbuf)}
| eof		{EOF}
